;##########################################################################
.386
.model flat, stdcall
option casemap:none
title Linker Verison
;##########################################################################
include C:\masm32\include\windows.inc
include C:\masm32\include\kernel32.inc
include C:\masm32\include\user32.inc
include C:\masm32\include\comdlg32.inc
includelib C:\masm32\lib\kernel32.lib
includelib C:\masm32\lib\user32.lib
includelib C:\masm32\lib\comdlg32.lib
;##########################################################################
m2m MACRO M1, M2
	push	M2
	pop	M1
ENDM
;##########################################################################
;##########################################################################
;##########################################################################
.const
	szAppTitle	db		"Linker Version", 0
	szMsgAbout	db		"Linker Version", 13, 10
			db		"Version 1.0", 13, 10
			db		"Coded by comrade <comrade2k@hotmail.com>", 13, 10
			db		"Web: http://www.comrade64.com/", 13, 10
			db		"http://comrade64.cjb.net/", 13, 10
			db		"http://comrade.ownz.com/", 13, 10
			db		"http://comrade.win32asm.com/", 13, 10
			db		"IRC: #asm, #coders, #win32asm on EFnet", 0
	szError		db		"Error!", 0
	szLinkerVersionFormat db	"Linker Version:", 13, 10, "%u.%u", 0
	szFileFilter	db		"All Supported Files (*.exe;*.dll;*.ocx;*.scr)", 0, "*.exe;*.dll;*.ocx;*.scr", 0
			db		"Executables (*.exe)", 0, "*.exe", 0
			db		"Dynamic Link Libraries (*.dll)", 0, "*.dll", 0
			db		"ActiveX Controls (*.ocx)", 0, "*.ocx", 0
			db		"Screensavers (*.scr)", 0, "*.scr", 0
			db		"All Files (*.*)", 0, "*.*", 0, 0
;##########################################################################
.data
;##########################################################################
.data?
	hFile		dd		?
	dwBytesWritten	dd		?
	data_start	equ		$
	szMessage	db		256 dup (?)
	szFileName	db		MAX_PATH dup (?)
	ofn		OPENFILENAME	<>
	img_dos_hdr	IMAGE_DOS_HEADER <>
	img_nt_hdrs	IMAGE_NT_HEADERS <>
	data_size	equ		$ - data_start
;##########################################################################
.code
start:	push	edi
	push	esi
	push	ebx
	xor	eax, eax
	mov	ecx, data_size shr 2
	mov	edi, data_start
	rep	stosd
	IF data_size AND 3
		mov	ecx, data_size and 3
		rep	stosb
	ENDIF
	invoke	GetModuleHandle, eax
	mov	[ofn.lStructSize], sizeof ofn
	mov	[ofn.hInstance], eax
	mov	[ofn.lpstrFilter], OFFSET szFileFilter
	mov	[ofn.lpstrFile], OFFSET szFileName
	mov	[ofn.nMaxFile], sizeof szFileName
	invoke	MessageBox, 0, ADDR szMsgAbout, ADDR szAppTitle, MB_OK OR MB_ICONASTERISK OR MB_APPLMODAL
	invoke	GetOpenFileName, ADDR ofn
	test	eax, eax
	jz	@@quit
	invoke	CreateFile, ADDR szFileName, GENERIC_READ, FILE_SHARE_READ, 0, OPEN_EXISTING, 0, 0
	mov	[hFile], eax
	inc	eax
	jz	@@err
	invoke	ReadFile, [hFile], ADDR img_dos_hdr, sizeof img_dos_hdr, ADDR dwBytesWritten, 0
	test	eax, eax
	jz	@@err
	cmp	[dwBytesWritten], sizeof img_dos_hdr
	jne	@@err
	invoke	SetFilePointer, [hFile], [img_dos_hdr.e_lfanew], 0, FILE_BEGIN
	cmp	eax, [img_dos_hdr.e_lfanew]
	jne	@@err
	invoke	ReadFile, [hFile], ADDR img_nt_hdrs, sizeof img_nt_hdrs, ADDR dwBytesWritten, 0
	test	eax, eax
	jz	@@err
	cmp	[dwBytesWritten], sizeof img_nt_hdrs
	jne	@@err
	movzx	eax, [img_nt_hdrs.OptionalHeader.MajorLinkerVersion]
	movzx	ecx, [img_nt_hdrs.OptionalHeader.MinorLinkerVersion]
	invoke	wsprintf, ADDR szMessage, ADDR szLinkerVersionFormat, eax, ecx
	invoke	MessageBox, 0, ADDR szMessage, ADDR szAppTitle, MB_OK OR MB_ICONASTERISK OR MB_APPLMODAL
	jmp	@@quit
@@err:	invoke	MessageBox, 0, ADDR szError, ADDR szAppTitle, MB_OK OR MB_ICONEXCLAMATION OR MB_APPLMODAL
	xor	eax, eax
@@quit:	pop	ebx
	pop	esi
	pop	edi
	push	eax	; for ExitProcess
	invoke	CloseHandle, [hFile]
	call	ExitProcess
;##########################################################################
;##########################################################################
;##########################################################################
end start